(defgroup laml nil
  "LAML customizations. LAML means Lisp Abstracted Markup Language.

With LAML it is possible to write HTML documents and CGI programs in Scheme.
For more informations see http://www.cs.auc.dk/~normark/laml/."
  :group 'emacs
  )

(defcustom laml-pp-helpful t
  "Show useful roles of constituents of selected LAML templates. 

LAML templates are activated by M-x insert-... in the various LAML styles."
  :type 'boolean
  :group 'laml)

(defcustom laml-single-string-approach nil
  "Controls whether the LAML mirror functions, and other similar functions, expect a single (concatenated) contents string.

The variable is important for the embed command.
If you use the html4.0 loose mirror this variable shold be nil."
  :type 'boolean
  :group 'laml)

(defcustom smart-word-determination t
  "With smart word determination a word is implicitely selected if the point is at the first character of a word.

If you do not use smart word determination you must explicitly select a string to embed. The variable is important for the embed command."
  :type 'boolean
  :group 'laml)


(defcustom concatenate-form 'con 
  "The Scheme string concatenate function to be used with LAML."
  :type 'symbol
  :group 'laml)

