;=>index.laml

(let ((issue (lambda (hd bd) (con (font-color red (b hd)) (br) bd (p))))
       (elisp-command (lambda (cmd descr) (con (kbd (b cmd)) (br) descr (p))))
      )
 (con
  (vertical-space 1)

  (con-space 
   (h 2 "Which Scheme Systems?")

   (indent-pixels 10
    (con
     (con-space 

     "The following table shows the existing LAML configurations by Scheme systems, Platform and Operating System:" (p)
     (let ((unix-scm 
             (font-size 2 (con "OK for solaris 6" (br) "OK for solaris 7"))
           )
           (unix-mz
             (font-size 2 (con "OK for solaris 7"))
           )
           (unix-guile
             (font-size 2 (con "OK for solaris 7"))
           )
           (pc-mz
             (font-size 2 (con "OK for NT4.0, Win 2000, Win 95, and Win98"))
           )
           (mac-dr
             (font-size 2 (con "Version 13 ported by javier_diaz_r to Mac G3" (br) 
                          (a-tag "http://www.cs.auc.dk/~normark/scheme/contributions/javierDiazR/" "Details and patch")))
           )
           (pc-dr
             (font-size 2 (con "Works in principle, but very slow. Only activation from interpreter via (laml ...)"))
           )
           (linux-mz (font-size 2 "OK"))
           (scm (a-tag "http://www-swiss.ai.mit.edu/~jaffer/SCM.html" "scm"))
           (mzscheme  (a-tag "http://www.cs.rice.edu/CS/PLT/packages/mzscheme/" "mzscheme"))
           (guile (a-tag "http://www.gnu.org/software/guile/guile.html" "guile"))
           (drscheme (a-tag "http://www.cs.rice.edu/CS/PLT/packages/drscheme/" "drscheme"))
          )

      (indent-pixels 10           
       (table-1 2
        (list 150 150 150 150)
        (make-list 4 green2)
        (list 
         (map b (list      "Scheme System"          "Platform"      "Operating System"        "Status"))

         (list             mzscheme               "unix"          "solaris-7"               (b "OK"))
         (list             mzscheme               "unix"          "linux"                   "probably OK")
         (list             mzscheme               "windows"       "win95"                   "OK")
         (list             mzscheme               "windows"       "win98"                   "OK")
         (list             mzscheme               "windows"       "nt40"                    (b "OK"))
         (list             mzscheme               "windows"       "win2000"                 (b "OK"))

         (list             guile                  "unix"          "solaris-7"               "OK")

         (list             scm                    "unix"          "solaris-7"               "OK")
         (list             scm                    "unix"          "solaris-6"               "?")
         (list             scm                    "unix"          "linux"                   "?")

         (list             drscheme               "windows"       "nt40"                    "OK")

      ))))

      (p)

      (con "A bold " (b "'OK'") " means that I use the combination myself, and that it works for me.
      An 'OK' means that am confident that the configuration works, and that it is supported in the distribution.
      (Perhaps I used it earlier, I have tested it to some degree, or others have reported positively on that combination.)
      When a combination is OK you should be able to install LAML with no or very reasonable efforts (GNU Emacs support included).
      If you use a combination not supported you should make some porting efforts, which is more difficult.")

      (p)
 
      "Currently I use MzScheme on both Unix (static LAML and for CGI programming) and Windows (Win2000, NT, Win98).
      Before that I used SCM on Unix.
      DRScheme is too slow for LAML purposes, at least for my taste; But as noticed, DRScheme works with LAML if you have time to wait.
      I do not use Guile in my daily work, but I have ported LAML to Guile and tested it in a reasonable way.
      LAML is also known to work with MzScheme on Linux.
      I have never used LAML on a Mac. 
      "
      ) (p)

     (con "As part of the LAML distribution we have a useful " (a-tag (abs-url "r4rs/r4rs-browser.html") "Scheme R4RS manual browser") ".
      My contribution is solely the indexing (which is not accurate in the index made from the TeXInfo source of the document).")
    )
  )
  )


  (con-space 
    (h 2 "Which Emacs?")
    (indent-pixels 10
      (con "I recommend that you use LAML from GNU Emacs. The Emacs interface makes it possible
            to activate LAML directly on a buffer, and to produce an HTML file in a very flexible way.
            The Emacs interface abstracts away the starting of the Scheme system, and the loading 
            of all the necessary files. 
            The Emacs interface works well on both the UNIX and PC (NT4.0/Win98/Win95) platforms.
            You can download " (a-tag "ftp://ftp.gnu.org/gnu/windows/emacs/" "a PC verion of Emacs") " (win95/98/NT) from the GNU FTP site.
            As of November 2000 I recommend version 20.7, but earlier versions will probably also work without problems. (I do not rely on 
            new Emacs features, as far as I am aware).")))


  (con-space 
    (a-name "non-standard")
    (h 2 "Which non-standard functions are used in LAML?")
    (indent-pixels 10
     (con 
      "The LAML software uses the following non-standard R4RS functions:"

      (p) 

      (table-3 0 (list 250 450)
        (list 
             (list (b "(current-time)")                  "Returns the number of seconds elapsed since January 1, 1970")
             (list (b "(sort-list list leq-fn)")         "Returns a sorted version of list. The sorting is based
                                                          on the function leq-fn, which returns when two elements in the
                                                          list are considered less than or equal")
             (list (b "(file-exists? file-path)")        "Returns whether a file named file-path (full path) exists.")
             (list (b "(delete-file file-name)")         "Deletes a file.")
             (list (b "(directory-exists? dir-path)")    "Returns whether the directory dir-path exists")
             (list (b "(copy-file source destination)")  "Copy the source file to destination file. Both source
                                                          and destination are supposed to be full paths")
       ) "top")

       (p)

      "In addition, the following functions are desirable although not used in the central pieces of the LAML software.
       If you cannot implement them, just relax..." 
      
      (p)

      (table-3 0 (list 250 450)
         (list
            (list (b "(make-directory-in-directory in-directory-path new-dir)") 
                                                         "Make a new directory new-dir in an existing directory path. Used in LENO and Course-plan.")
            (list (b "(directory-list path)") 
                                                         (con "Return a list of files and directories in path. As of version 15, this 
                                                          function is only used in " (kbd "laml-ls") "."))
            (list (b "(mail receiver title contents)")   "Send email to receiver with title and contents.")
       ))

      (p)

      (con "The Scheme system compatibility files in " (kbd "lib4/compatibility/") " provide implementations of the functions
       mentioned above.
       (In case no implementation is possible, we call the error procedure.)
       In the distribution, there are a compatibility files for a number of Scheme systems and operating systems.
       ")
   )
  ))

  (con-space
    (a-name "installation")
    (h 2 "Installation")
    (indent-pixels 10 (con-space 
    "You are supposed to unzip the LAML distribution into a directory of your choice.
     Next you have to make a few modifications to a configuration file in order to describe properties of your installation.
     Finally you run a particular Scheme program which effectuates the configuration process.
     See the " (a-tag "info/laml-easy-installation.html" "LAML installation guide") "for details on that."
     "We assume that you are a competent Scheme programmer, and as such that you are able to fix simple installation problems
     that may occur.")))

  (con-space
    (a-name "processing")
    (h 2 "Processing LAML files")
    (indent-pixels 10 (con-space
    "By processing an LAML file (a file with extension laml) the LAML Scheme expressions are translated to HTML.
    Thus, by processing the file f.laml you typically get g.html in the same directory.
    Usually f equals g (depending on the method of processing)." (p)

    (con "When we start a LAML process, we transfer a bit of context to the processing which gives us knowledge about
     the name of the file, on which the laml source resides, and the directory in which the source file is placed.
     In addition, the underlying Scheme process needs to know where the LAML software is located (and a few other
     options to allow correct processing using a particular Scheme engine).") (p)

    "We support the following LAML processing methods:"

    (ul-1 (list
      (issue "Via an Emacs text editor"
             (con "A single keystroke (" (b (kbd "C-o")) " or double key stroke "  (b (kbd "C-x C-o")) ") or a single Emacs command ("
             (b (kbd "M-x laml-process-current-buffer")) " or " (b (kbd "M-x laml-sync-process-current-buffer")) ")
              starts a Scheme processor on the buffer with
              an LAML file. This is undoubtedly the most flexible method of LAML activation.
              It requires Emacs to be configured appropriately.
              The Emacs configuration is described as part of the LAML installation guide referred to above."))

      (issue "Via an operating system command file called laml"
             (con-space "From a command prompt activate the laml command on an laml file in the current directory:"
                        (pre (con (b "c:\\users\\kurt\\laml> ") (kbd "laml file")))
             "The file is written without the laml extension. First, however, insert the "  (kbd "laml/bin")  " directory into your PATH. 
              Also, on UNIX, make sure that the command file is executable (" (kbd "chmod 775 laml,") " for instance)." (p)

             (con "On some platforms we also support the variant"
             (pre (con (b "c:\\users\\kurt\\laml> ") (kbd "absolute-laml absolute-path file")))
             "where absolute-path is the file path leading to file (again given without extension). This variant
              is useful from cron jobs, which starts LAML processing at some given point in time.") (p)

             "The laml command depends on bin/SETENV.EXE which does not work
              on NT4.0 and Windows 2000, but it works on Win95/98. Thus, it is currently
              not possible to use the this mode of activation on Window NT or Windows 2000. The laml command works on Unix."))

      (issue "Directly from a running Scheme interpreter in Emacs"  

             (con "Activation the Emacs command " (kbd (b "M-x run-laml-interactively")) ". This gives you 
                   a Scheme system in which LAML has been loaded. This means of LAML execution is useful for interactive experiments and for debugging purposes." (p)
                  "Now use the " (a-tag (abs-url "man/laml.html#laml") (kbd "laml"))  " procedure to process a laml file.
                        You can also use one of the " (a-tag (abs-url "man/laml.html#SECTION7") "LAML tools")  ". Use the parameter less procedures " (kbd "laml-cd") " to change the
                   working directory, " (kbd "laml-pwd") " to find out about the working directory, and " (kbd "laml-ls") " to list the working directory (" 
                   (kbd "laml-ls") " depends on " (kbd "directory-list") ")."))
                  
      (issue (con (a-name "starting-laml-non-emacs") "Directly from a running Scheme interpreter (outside Emacs)")
             (con 
              
              "First start your Scheme system." (p)
              (ol-1
               (list
                (con "Define the variable " (kbd "laml-dir") " as the file path of your LAML directory. For instance
                 " 
                 (pre (kbd "   (define laml-dir \"c:/users/kurt/laml/\")")) (p))

                (con "Load laml-init.scm file from the laml directory by " 
                     (pre (kbd "   (load (string-append laml-dir \"laml-init.scm\"))")) (p)
                     "This loads the fundamental setup file " (kbd "laml.scm") ", and as such " (kbd "lib4/general.scm") ", 
                      and the Scheme necessary compatility file and - if requested in the your installation file " (kbd "configuration") " - your laml init file.
                      Other useful stuff is also loaded by " (kbd "laml-init.scm") ", and you will be located in one of LAML example directories." (p))

                (con 
                "Now process LAML files with the " (kbd "laml") " procedure, for instance:"

                   (pre (kbd "   (laml \"index.laml\")"))

                "LAML finds file in the so-called LAML startup directory. Change the LAML startup directory
                 with:"

                   (pre (kbd (con "   (laml-cd " (em "new-dir") ")")))

                 "where " (em "new-dir") " can be absolute, relative, or \"..\". " "The function " (kbd "laml-pwd") " returns the current LAML startup directory."  (p)

                 "Please also notice all the " (a-tag (abs-url "man/laml.html#SECTION7") "other LAML tools") " that can be activated from this level."

                )

                )
               ) (p)

               "If possible, you can arrange that the first two steps are carried out in the
                init file of your Scheme system."

              )
 
     ) ))

     (con "If specified in the configuration file, a " (em "laml init file") " - such as " (kbd ".laml") " from you home directory - 
      can be used for your personal LAML customization purposes. The LAML init file is loaded as the 
      last action in " (kbd "laml.scm") ". You can redefine stuff from " (kbd "laml.scm") " and " (kbd "general.scm") ", but not LAML style or tool stuff (which is loaded after " (kbd "laml.scm") ").")
      

  )))
    

  (con-space
    (h 2 "The Scheme Elucidator")
    (indent-pixels 10
      (con "Elucidative Programming in Scheme is supported by a tool which we call the Scheme Elucidator. "
           "Elucidative programming is a variant of literate programming in which programs and internal
            documentation is presented in an Internet Browser. The Scheme Elucidator is one of the most
            substantial LAML-based pieces of software I have written." (p)
           "The Scheme Elucidator is an integrated part the LAML distribution. "
           "With respect to installation and setup of the Scheme Elucidator see the " 
           (a-tag (abs-url "styles/elucidator/elucidator-installation.html") "Elucidator Installation page") ". "
           "In addition, the distribution contains " 
           (a-tag (abs-url "styles/elucidator/doc/elucidator.html") "elucidative documentation of the Elucidator tool") "
           itself. See also the " 
           (a-tag "http://www.cs.auc.dk/~normark/elucidative-programming" "Home Page of Elucidative Programming")
            " on the Aalborg University WWW site."

    )))


  (con-space (a-name "emacs-support")
    (h 2 "Emacs support")
    (indent-pixels 10
     (con "As an integral part of this software package you will find special LAML support from the Emacs editor, including
      a LAML mode with both key bindings and menu entries.
      If you followed the installation steps you should be able to use LAML from emacs."
     (p)

     "The following gives an overview of the most important, general LAML Emacs commands.
     "

     (ul-1 (list
       (elisp-command "laml-process-current-buffer" 
                      (con "Start LAML asynchronously on the current buffer, say f.laml. This defines the file f.html. " (br) "
                       In the standard setup this command is bound to " (kbd "C-o") "."))
       (elisp-command "laml-sync-process-current-buffer"
                      (con "Start LAML synchronously on the current buffer, say f.laml. This defines the file f.html.  " (br) "
                       In the standard setup this command is bound to " (kbd "C-x C-o") "."))
       (elisp-command "laml-process-buffer" (con "Start LAML on particular buffer of your choice, say " (kbd "b") ". This typically creates the file " (kbd "b.html") ))
       (elisp-command "embed" "Embed the currently selected substring or word into a LAML form. A word is selected implicitly by pointing at its first character.
                               This command handles the necessary string splitting and string concatenation.")
       (elisp-command "unembed"  (con "Unembeds the currently selected form. This is the reverse command to " (b "embed") ".
                                 The form is selected by pointing at the start parenthesis or a character in the form name.
                                 This command unnests the form, joins neighboring strings, and gets rid of a possibly unnecessary string concatenation form."))
       (elisp-command "laml-mode" "Set the major mode of the current buffer to LAML mode.")
       (elisp-command "laml-insert-template" "Insert a stored template. You are prompted for a particular one.")
       (elisp-command "insert-laml-template" "An alias for laml-insert-template")
       (elisp-command "nest" "Nest the current Lisp form into an extra form (a general lisp editing command)")
       (elisp-command "unnest" "The opposite command to nest")
))

     "The " (b "embed") " and " (b "unembed") " commands are very important, because they help the LAML user to embed portions of a string into a Lisp form.
      Stated in a slightly different way, these commands alleviate the inconvenience caused by the
      string passing problem (the problem that occurs because
      all strings must be passed explicitly to LAML functions - this is the main point which 
      in a significant way makes LAML different from
      the SGML family of mark up languages).
      The embed command is controlled by the two Emacs Lisp variables " (kbd "laml-single-string-approach") " and
      " (kbd "smart-word-determination.") " Please see the documentation of these (via C-h v) in order to addapt " (b "embed") " to your taste and needs.
      In the standard setup, " (b "embed") " can be activated via " (b "C-x C-e") ". " (b "Unembed") " is similarly activated by " (kbd "C-x C-r") "." (p)

     (con "Besides these, a variety of specialized template insertion commands are available. They all start with " (b (kbd "insert-")) ".
      Use the Emacs completion facility to find out about these.") (p)

      (con "There also exists a number of more specific emacs command for the "
      (a-tag (abs-url "styles/elucidator/man/elucidator.html#emacs") "Elucidator") ", the " 
      (a-tag (abs-url "styles/manual/man/manual.html") "Manual style") ", and for "
      (a-tag (abs-url "styles/lecture-notes/man/lecture-notes.html") "LENO") ".
      See the relevant manual pages for description of these.") (p)

      "In case you want to change the key bindings used by Emacs LAML mode, you will have to change these in 
       " (kbd "emacs-support/dot-emacs-contribution.el") 

     )))

  (con-space
    (h 2 "Slide presentations of LAML")
    (indent-pixels 10
      (con "Besides the papers about LAML available from the " (a-tag "http://www.cs.auc.dk/~normark/laml" "LAML home page")
           ", there is also a " (a-tag (abs-url "slides/goerlitz-00/goerlitz.html") "slide presentation") " 
           of the ideas behind LAML. The slides were - in the original version - presented at the Lisp User Group Meeting in Amsterdam
           in 1999. There is also a " (a-tag (abs-url "slides/lugm-99-amsterdam/html/laml-brief.html") "brief version") " available. The slides are made by the LENO tool, which itself is LAML based.
           The brief version illustrates the LENO trail facility. The slides are contained
           in the LAML distribution." (p)


  ))

  (con-space
    (h 2 "Change logs")
    (indent-pixels 10
      (con "We keep track of the changes from one version to the next. Below you can navigate to these"
           (ul-1 (list 
             (a-tag (abs-url "change-logs/version-12-to-13.txt") "Changes from version 12 to 13")
             (a-tag (abs-url "change-logs/version-13-to-14.txt") "Changes from version 13 to 14")
             (a-tag (abs-url "change-logs/version-14-to-15.txt") "Changes from version 14 to 15")
             (a-tag (abs-url "change-logs/version-15-to-16.txt") "Changes from version 15 to 16")
           ))
     )))


  (con-space
    (h 2 "Porting LAML to other Scheme Systems")
    (indent-pixels 10
      (con "In order to port the LAML software package to another Scheme system you will need to carry our some programming
            work. I have written a " (a-tag (abs-url "info/porting-laml.html") "guide for people who want to port LAML") " to another Scheme system."
     )))

  

  (con-space
    (h 2 "Known bugs and problems")
     (ol-1 (map con-p (list
        "The laml bat files for NT4.0 and Windows 2000 do not work. It does not find in which directory it is started, and
         it therefore fails to transfer this information to the Scheme process.
         As a consequence, all files are written into the laml directory instead of being written
         into the same directory as the LAML source file."

        "The Emacs stuff may cause conflicts with other Emacs packages. As pointed out by several people,
         all Emacs Lisp functions should have a 'laml-' prefix. This is a major work, which I postpone. Is there
         a program that makes such conversions? If not, it would be worthwhile to make one, perhaps..."

      ))))

  (vertical-space 1)

  (con-space "Kurt Nrmark" (br) "Aalborg University" (br) kn-email)
 
)))